local Slots = {
	Event = {},
	data = {
		playerID = "",
		update = false,
		meter_x = 0,
		meter_y = 0,
		current = 25,
		pot = 500,
	},
	 
}

local spinning = false
local spuntime = 0

function Slots.Event.LoadEnd(identifier)
	if identifier == "SinsSlots" then
		Slots.data.playerID = Inspect.Unit.Lookup("player")

		print("SinsSlots loaded. /Slots")
	end
end




	

local function AddDragFrame(window)

  function window.Event:LeftDown()
    self.leftDown = true
    local mouse = Inspect.Mouse()
    self.originalXDiff = mouse.x - self:GetLeft()
    self.originalYDiff = mouse.y - self:GetTop()
    local left, top, right, bottom = window:GetBounds()
    window:ClearAll()
    window:SetPoint("TOPLEFT", UIParent, "TOPLEFT", left, top)
    window:SetWidth(right-left)
    window:SetHeight(bottom-top)
  end

  function window.Event:LeftUp()
    self.leftDown = false
  end

  function window.Event:LeftUpoutside()
    self.leftDown = false
  end

  function window.Event:MouseMove(x, y)
    if not self.leftDown then
      return
    end
    window:SetPoint("TOPLEFT", UIParent, "TOPLEFT", x - self.originalXDiff, y - self.originalYDiff)
	Slots.data.meter_x = x - self.originalXDiff
	Slots.data.meter_y = y - self.originalYDiff
  end
end

-- start frames
local main = UI.CreateContext("UI")
local box = UI.CreateFrame("Frame", "box", main)


local left = UI.CreateFrame("Texture", "Left", main)
local mid = UI.CreateFrame("Texture", "mid", main)
local right = UI.CreateFrame("Texture", "right", main)

local spin = UI.CreateFrame("RiftButton", "spin", main)

local credits = UI.CreateFrame("Text", "credits", main)
local jackpot = UI.CreateFrame("Text", "Jackpot", main)


box:SetPoint("CENTER",UIParent,"CENTER",100,100)
box:SetWidth(300)
box:SetHeight(200)
box:SetAlpha(.1)
box:SetVisible(true)
box:SetBackgroundColor(0,0,0)

left:SetPoint("CENTER",box,"CENTER",-80,0)
mid:SetPoint("CENTER",box,"CENTER",0,0)
right:SetPoint("CENTER",box,"CENTER",80,0)
spin:SetPoint("CENTER",box,"CENTER",0,100)

jackpot:SetPoint("CENTER",box,"CENTER",0,-60)
credits:SetPoint("CENTER",box,"CENTER",0,60)


		
		left:SetVisible(true)
		mid:SetVisible(true)
		right:SetVisible(true)	
		spin:SetVisible(true)
		jackpot:SetVisible(true)
		credits:SetVisible(true)

spin:SetWidth(90)
spin:SetHeight(45)
spin:SetAlpha(1)

left:SetWidth(74)
left:SetHeight(74)
left:SetAlpha(1)

mid:SetWidth(74)
mid:SetHeight(74)
mid:SetAlpha(1)

right:SetWidth(74)
right:SetHeight(74)
right:SetAlpha(1)

left:SetTexture("SinsSlots","green.PNG")
mid:SetTexture("SinsSlots","blue.PNG")
right:SetTexture("SinsSlots","purple.PNG")


credits:SetFontSize(15)
jackpot:SetFontSize(20)

spin:SetText(" S p i n ")
credits:SetText("Credits: 10")
jackpot:SetText("Relic: 500")


local lastCall = Inspect.Time.Real()
math.randomseed(lastCall)
AddDragFrame(box)


function Slots.Event.Death(info)

if (info.caster) and (info.target) then
if info.caster == Slots.data.playerID and info.target ~= Slots.data.playerID then

Slots.data.current = Slots.data.current + 1


end
end
end



function getImage(chance)
local x=""
if chance <=100 then
x = "orange.PNG"
elseif chance >100 and chance <= 300 then
x = "purple.PNG"
elseif chance >300 and chance <= 600 then
x= "blue.PNG"

else
x="green.PNG"
end

return x


end

function spin.Event:LeftPress()


if(Slots.data.current <= 0) then

print("Kill mobs to gain more credits")
Slots.data.current = 0

end

if(Slots.data.current >0)then
spin:SetVisible(false)
Slots.data.current = Slots.data.current - 1
Slots.data.pot = Slots.data.pot + 1


spinning = true
spuntime = Inspect.Time.Real() 
--[[
local chance1 = math.random(1000)
local chance2 = math.random(1000)
local chance3 = math.random(1000)

local result1 = getImage(chance1)
local result2 = getImage(chance2)
local result3 = getImage(chance3)

left:SetTexture("SinsSlots",result1)
mid:SetTexture("SinsSlots",result2)
right:SetTexture("SinsSlots",result3)

--]]



end




	end

function fade()


local now = Inspect.Time.Real()
	if (now<lastCall+.10) then 
		return
	end
	

credits:SetText("Credits: "..Slots.data.current)
jackpot:SetText("RELIC: "..Slots.data.pot)
spin:SetWidth(90)
spin:SetHeight(45)

if spinning == true then

local chance1 = math.random(1000)
local chance2 = math.random(1000)
local chance3 = math.random(1000)

local result1 = getImage(chance1)
local result2 = getImage(chance2)
local result3 = getImage(chance3)

left:SetTexture("SinsSlots",result1)
mid:SetTexture("SinsSlots",result2)
right:SetTexture("SinsSlots",result3)



if now > spuntime + 3 then
spinning = false
spin:SetVisible(true)
--payout()

if (result1 == result2) and result1 == result3 then

if result1 == "green.PNG" then
print("You win the uncommon prize (25)")
Slots.data.current = Slots.data.current + 25
elseif(result1 =="blue.PNG") then
print("You win the rare prize (75)")
Slots.data.current = Slots.data.current + 75
elseif(result1 =="purple.PNG") then
print("You win the epic prize (250)")
Slots.data.current = Slots.data.current + 250
elseif(result1 =="orange.PNG") then
print("You win the relic prize ("..Slots.data.pot..")")
Slots.data.current = Slots.data.current + Slots.data.pot
Slots.data.pot = 500
end 

else

print("You lost the spin")

end






end
end
lastCall = now
end


local function Slotssave()
 	 
Slot_meter_x = Slots.data.meter_x
Slot_meter_y = Slots.data.meter_y
Slot_earned = Slots.data.current
Slot_pot = Slots.data.pot
   end


local function Slotsload()

if Slot_meter_x then
Slots.data.meter_x = tonumber(Slot_meter_x)
end

if Slot_meter_y then
 Slots.data.meter_y = tonumber(Slot_meter_y)
 end
 
 if Slot_earned then
 Slots.data.current = tonumber(Slot_earned)
 end
 
 if Slot_pot then
 
 Slots.data.pot = tonumber(Slot_pot)
 end

Slots.data.update = true

box:ClearAll()
box:SetPoint("TOPLEFT", UIParent, "TOPLEFT", Slots.data.meter_x, Slots.data.meter_y)
box:SetWidth(300)
box:SetHeight(200)

		box:SetVisible(true)
		left:SetVisible(true)
		mid:SetVisible(true)
		right:SetVisible(true)	
		spin:SetVisible(true)
		jackpot:SetVisible(true)
		credits:SetVisible(true)

   end
function Slots.Event.SlashHandler(str)
	
	local cmd, arg = string.match(str, "(%a+) ?(.*)")

		
		if cmd == "show" then
		box:SetVisible(true)
		left:SetVisible(true)
		mid:SetVisible(true)
		right:SetVisible(true)	
		spin:SetVisible(true)
		jackpot:SetVisible(true)
		credits:SetVisible(true)
		elseif cmd == "hide" then
		box:SetVisible(false)
		left:SetVisible(false)
		mid:SetVisible(false)
		right:SetVisible(false)	
		spin:SetVisible(false)
		jackpot:SetVisible(false)
		credits:SetVisible(false)
		end
		
	end	
	
	table.insert(Event.System.Update.Begin, {fade, "SinsSlots", "fade"})

table.insert(Event.Combat.Death, 		{Slots.Event.Death, 		"SinsSlots", "Handle Death"})
table.insert(Event.Addon.SavedVariables.Save.Begin, {Slotssave, "SinsSlots", "Save variables"})
table.insert(Event.Addon.SavedVariables.Load.End, {Slotsload, "SinsSlots", "Load variables"})
table.insert(Event.Addon.Load.End, 				{Slots.Event.LoadEnd, 			"SinsSlots", "Init"})
table.insert(Command.Slash.Register("Slots"), 		{Slots.Event.SlashHandler, 	"SinsSlots", "Slash"})